﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TabsStudioSorter
{
    public partial class EditRuleDialog
    {
        public EditRuleDialog(SortingRule rule_)
        {
            rule = rule_;
            InitializeComponent();
            textBoxName.Focus();

            {
                int i = 0;
                foreach (SortingRuleType type in Enum.GetValues(typeof(SortingRuleType)))
                {
                    comboBox1.Items.Add(type.ToString());
                    if (type == rule.type)
                        comboBox1.SelectedIndex = i;
                    ++i;
                }
            }

            textBoxName.Text = rule.name;
            textBoxMatch.Text = rule.match;
            checkBox1.IsChecked = rule.inverseOrder;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                System.Text.RegularExpressions.Regex reg = new System.Text.RegularExpressions.Regex(textBoxMatch.Text);
            }
            catch (System.Exception ex)
            {
                MessageBox.Show(this, ex.Message, "Match regex error", MessageBoxButton.OK, MessageBoxImage.Error);
                return;
            }

            rule.name = textBoxName.Text;
            rule.match = textBoxMatch.Text;
            rule.inverseOrder = (bool)checkBox1.IsChecked;
            rule.type = (SortingRuleType)Enum.Parse(typeof(SortingRuleType), (string)comboBox1.SelectedItem);
            DialogResult = true;
        }

        private SortingRule rule;
    }
}
